#include <SoftwareSerial.h>
SoftwareSerial mySerial(0, 1); //RX, TX

int redPin= 6;
int greenPin = 4;
int bluePin = 5;

#define NOFIELD 514L    // Analog output with no applied field, calibrate this

// Uncomment one of the lines below according to device in use A1301 or A1302
// This is used to convert the analog voltage reading to milliGauss
#define TOMILLIGAUSS 1953L  // For A1301: 2.5mV = 1Gauss, and 1024 analog steps = 5V, so 1 step = 1953mG
// #define TOMILLIGAUSS 3756L  // For A1302: 1.3mV = 1Gauss, and 1024 analog steps = 5V, so 1 step = 3756mG

void setup() 
{
  mySerial.begin(9600);
  pinMode(redPin, OUTPUT);
  pinMode(greenPin, OUTPUT);
  pinMode(bluePin, OUTPUT);
}

void loop() 
{
    delay(1000);
    DoMeasurement();
}

void DoMeasurement()
{
// measure magnetic field
  int raw = analogRead(3);   // Range : 0..1024

//  Uncomment this to get a raw reading for calibration of no-field point
//  mySerial.print("Raw reading: ");
//  mySerial.println(raw);

  long compensated = raw - NOFIELD;                 // adjust relative to no applied field 
  long gauss = compensated * TOMILLIGAUSS / 1000;   // adjust scale to Gauss

  mySerial.print(gauss);
  mySerial.print(" Gauss ");

  if (gauss > 0){
    mySerial.println("(South pole - DARK)");
    setColor(255, 0, 0); // Red Color
  }
  else if(gauss < 0){
    mySerial.println("(North pole - GREEN)");
    setColor(0, 255, 0); // Green Color
  }
  else{
    mySerial.println();
    setColor(0, 0, 255); // Blue Color
  }
}

void setColor(int redValue, int greenValue, int blueValue) {
  analogWrite(redPin, redValue);
  analogWrite(greenPin, greenValue);
  analogWrite(bluePin, blueValue);
}

